<template>
  <div>
    <BasicTable @register="registerTable" :clickToRowSelect="false">
      <template #toolbar>
        <Authority value="api:yt:message:post">
          <a-button type="primary" @click="handleCreate"> 新增消息配置 </a-button>
        </Authority>
        <Authority value="api:yt:message:delete">
          <Popconfirm
            title="您确定要批量删除数据"
            ok-text="确定"
            cancel-text="取消"
            @confirm="handleDeleteOrBatchDelete(null)"
          >
            <a-button color="error" :disabled="hasBatchDelete"> 批量删除 </a-button>
          </Popconfirm>
        </Authority>
      </template>
      <template #config="{ record }">
        <a-button type="link" class="ml-2" @click="showData(record)"> 查看配置 </a-button>
      </template>
      <template #status="{ record }">
        <Switch
          :checked="record.status === 1"
          :loading="record.pendingStatus"
          checkedChildren="启用"
          unCheckedChildren="禁用"
          @change="(checked:boolean)=>statusChange(checked,record)"
        />
      </template>
      <template #action="{ record }">
        <TableAction
          :actions="[
            {
              label: '编辑',
              auth: 'api:yt:message:update',
              icon: 'clarity:note-edit-line',
              onClick: handleEdit.bind(null, record),
            },
            {
              label: '删除',
              auth: 'api:yt:message:delete',
              icon: 'ant-design:delete-outlined',
              color: 'error',
              popConfirm: {
                title: '是否确认删除',
                confirm: handleDeleteOrBatchDelete.bind(null, record),
              },
              ifShow: record.status == 0,
            },
          ]"
        />
      </template>
    </BasicTable>
    <ConfigDrawer @register="registerDrawer" @success="handleSuccess" />
  </div>
</template>
<script lang="ts">
  import { defineComponent, h, nextTick } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { messageConfigPage, deleteMessageConfig } from '/@/api/message/config';
  import { useDrawer } from '/@/components/Drawer';
  import ConfigDrawer from './ConfigDrawer.vue';
  import { columns, searchFormSchema } from './config.data';
  import { Modal, Popconfirm } from 'ant-design-vue';
  import { JsonPreview } from '/@/components/CodeEditor';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useBatchDelete } from '/@/hooks/web/useBatchDelete';
  import { Switch } from 'ant-design-vue';
  import { setMessageConfigStatus } from '/@/api/message/config';
  import { Authority } from '/@/components/Authority';

  export default defineComponent({
    name: 'MessageConfigManagement',
    components: { BasicTable, ConfigDrawer, TableAction, Switch, Authority, Popconfirm },
    setup() {
      const [registerDrawer, { openDrawer }] = useDrawer();
      function handleSuccess() {
        reload();
      }

      const [registerTable, { reload, setProps, setSelectedRowKeys }] = useTable({
        title: '消息配置列表',
        api: messageConfigPage,
        columns,
        formConfig: {
          labelWidth: 120,
          schemas: searchFormSchema,
        },
        useSearchForm: true,
        showTableSetting: true,
        bordered: true,
        showIndexColumn: false,
        actionColumn: {
          width: 200,
          title: '操作',
          dataIndex: 'action',
          slots: { customRender: 'action' },
          fixed: 'right',
        },
      });
      const { hasBatchDelete, handleDeleteOrBatchDelete, selectionOptions, resetSelectedRowKeys } =
        useBatchDelete(deleteMessageConfig, handleSuccess, setProps);
      selectionOptions.rowSelection.getCheckboxProps = (record: Recordable) => {
        // Demo:status为1的选择框禁用
        if (record.status === 1) {
          return { disabled: true };
        } else {
          return { disabled: false };
        }
      };
      nextTick(() => {
        setProps(selectionOptions);
      });

      function handleCreate() {
        openDrawer(true, {
          isUpdate: false,
        });
      }

      function handleEdit(record: Recordable) {
        openDrawer(true, {
          record,
          isUpdate: true,
        });
      }

      function showData(record: Recordable) {
        Modal.info({
          title: '当前配置',
          width: 600,
          centered: true,
          maskClosable: true,
          content: h(JsonPreview, { data: JSON.parse(JSON.stringify(record.config)) }),
        });
      }
      const statusChange = async (checked, record) => {
        setProps({
          loading: true,
        });
        setSelectedRowKeys([]);
        resetSelectedRowKeys();
        const newStatus = checked ? 1 : 0;
        const { createMessage } = useMessage();
        try {
          await setMessageConfigStatus(record.id, record.messageType, newStatus, record.tenantId);
          if (newStatus) {
            createMessage.success(`启用成功`);
          } else {
            createMessage.success('禁用成功');
          }
        } finally {
          setProps({
            loading: false,
          });
          reload();
        }
      };

      return {
        registerTable,
        registerDrawer,
        showData,
        handleCreate,
        handleEdit,
        handleSuccess,
        handleDeleteOrBatchDelete,
        hasBatchDelete,
        statusChange,
      };
    },
  });
</script>
